
#include "usgard.h"
#include "inpvars.h"

jp_op	=	$C3

.org 0

 ld (INP_LIBADDR),hl
 ld hl,INP_LIBLINK
 ld (hl),jp_op
 inc hl
 ld de,&FuncBrancher
 ld (hl),e
 inc hl
 ld (hl),d

 ld a,(ROM_VERS)
 ld bc,ROMVersEnd - ROMVersStart
 ld hl,&ROMVersEnd - 1
 push hl
 cpdr
 pop hl
 inc hl
 add hl,bc
 add hl,bc
 call LD_HL_MHL
 ld a,jp_op
 ld (INP_WAITKEY),a
 ld (INP_WAITKEY+1),hl

 ld hl,&InputInt
 call INT_INSTALL

 ret


ROMVersStart:
.db $2A	;v2.0
.db $57	;v3.0A
.db $8E	;v4.0
.db $97	;v8.0
.db $91	;v9.0
.db $35	;v10.0
ROMVersEnd:
WaitKeyAddr:
.dw $3EAC	;v2.0
.dw $3EB0	;v3.0A
.dw $3EB3	;v4.0
.dw $3EB7	;v8.0
.dw $3E87	;v9.0
.dw $3EA2	;v10.0
;keycode3 tables:
;v2.0: $0660
;v3.0A - v10.0: $0669


FuncBrancher:
 push de
 di
 inc sp\ inc sp
 ex (sp),hl
 ld e,(hl)
 inc hl
 ex (sp),hl
 dec sp\ dec sp
 ei
 push af
 push hl
 ld d,0
 ld hl,&LibFuncs
 ex de,hl
 add hl,hl
 add hl,de
 ld e,(hl)
 inc hl
 ld d,(hl)
 ld hl,(INP_LIBADDR)
 add hl,de
 ld ($8C8F+1),hl
 pop hl
 pop af
 pop de
 jp $8C8F


LibFuncs:
.dw InputString
.dw GetKey3

#include "input.h"

.end
